function [ energy ] = compute_energy(R, Zs, Cs, Is, Ks, Ns, NNs, Ws, param, settings)

alpha = param.alpha;
sigma_w = param.sigma_w;
mu_w = param.mu_w;



ggamma = param.ggamma;


% energy = P(R|Z,C,W)*P(Z)*P(C)*P(W)
% log_energy = logP(R|Z,C,W)+logP(Z)+logP(C)+logP(W)
%

%likelihood term
lk = compute_likelihood(R, Zs, Cs, Is, Ws, param, settings );


% remove parts of z with no usages
% this is necessary for the finite case of sampling Z, since then we 
% might have all-zero columns
zeroInd = find( sum(Zs,1) == 0 );
Zs( :, zeroInd ) = [];


%prior on Z
 
% [N K] = size(Zs);
% hst = zeros(1,K);
% for k=1:K
%     hst(k)=bin2dec2(Zs(:,k));
% end
% 
% K_plus = histc(hst,unique(hst));
% dd=0;
% for t=1:length(K_plus)
%   dd= dd + gammaln(K_plus(t)+1);
% end
% K_plus=sum(K_plus);
% harm = sum(ones(1, N)./(1:N));
% fac = 0;
% 
% m=sum(Zs,1);
% for t=1:K_plus
%     fac= fac+ gammaln(N-m(t)+1)+gammaln(m(t)) - gammaln(N+1);
%   
% end
% lpzz = (K_plus)*log(alpha)-(alpha*harm)+fac-dd
sigma_w = param.sigma_w;
mu_w = param.mu_w;


% % this gives the same result as the one above (the one commented out)
lpz = lpdfIBP( Zs, alpha );
% assert(abs(lpz-lpzz)<10^(-6))

%prior on C
%logP(C) = Sum logP(C_m), m=1,...size(Z,2)
lpc=0;
for m=1:size(Zs,2)
    KK = Ks(m);

    temp = 0;
    for i=1:KK
        temp  = temp + gammaln(NNs{m}(i));
    end
    zg = gammaln(ggamma)+KK*log(ggamma) +temp - gammaln(ggamma+Ns(m));
    lpc=lpc+zg;
end


%prior on W
lpw=0;
for m=1:size(Zs,2)
    pw=0;
    for k=1:Ks(m)
        for l=1:Ks(m)
            pw=pw-0.5*log(2*pi*sigma_w^2) -((Ws{m}(k,l)-mu_w)^2)/(2*sigma_w^2);
%                w_cl=Ws{m}(k,l);
%               pw= pw -log(2) -0.5*log(2*pi) + log((1/param.sigma_w1)*exp(-((w_cl-param.mu_w1)^2)/(2*(param.sigma_w1^2))) ...
%                    +(1/param.sigma_w2)*exp(-((w_cl-param.mu_w2)^2)/(2*(param.sigma_w2^2))  ));     
%             
        end
    end
    lpw=lpw+pw;
end

energy =lk + lpz + lpc + lpw;
 
           

end
