% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: February 2012
% Modified: August 2012

function [ st ] = compute_err( param, settings )
% function that computes the train and test error and reconstructs the link
% matrix based on the trained model

test_count = sum(settings.test_mask(:) );
train_count = sum(sum(settings.train_mask ));

% compute for several samples
N=size(param.R,1);
p=zeros(N,N);
for i = 1:settings.evaluation_window
    
    for m=1:size(param.Zs_iter{ end - i + 1 },2)
        
        
        Is{m} = find(param.Zs_iter{ end - i + 1 }(:,m));
    end
    [Rconstr]=construct_links(param.Zs_iter{end - i + 1}, Is, param.Cs_iter{end - i + 1}, param.Ws_iter{end - i + 1}, param.bias_iter(end - i + 1) );
    err = ( param.R -  Rconstr).^2;
    
    train_err(i) = sum(sum( settings.train_mask .* err )) / train_count;
    test_err(i) = sum(sum(  settings.test_mask .* err )) / test_count;
    param.bias=param.bias_iter(end - i + 1);
    [ lkl_trn(i)  T lkl_tst(i) ] = compute_likelihood(param.R, param.Zs_iter{end-i+1}, param.Cs_iter{end-i+1}, Is, param.Ws_iter{end-i+1}, param, settings);
     p=p+sigmoid_func(T+param.bias_iter(end-i+1));
    
end


% compute the bernulli probabilities' matrix (NxN)
st.bern_prob=p./settings.evaluation_window;

%create R from the trained model
st.Rreconstructed = rand(N,N)<st.bern_prob;

% average
st.train_err = mean( train_err );
st.test_err = mean( test_err );
st.test_count=test_count;
st.train_count=train_count;
st.ll_test_vector=exp(lkl_tst);
%st.ll_test=mean(exp(lkl_tst));
st.ll_test=log(mean(exp(lkl_tst-max(lkl_tst))))+max(lkl_tst);
end



