% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: February 2012


function [ lkl T_old] = compute_likelihood_new(i, zm_old, cm_old, im_old, wm_old, R, zm, cm, im, wm, param, settings)

N = size(R, 1);

T_old = param.T;





rhor=0;
rver=0;

for m=1:size(zm_old,2)
    if any(zm_old(:,m))
        C_r = ones(1,N);
        C_r(im_old{m})=cm_old{m};
        z=zm_old(:,m)*zm_old(:,m)';
        w=wm_old{m}(C_r, C_r);
        rhor=rhor+z(i,:).*w(i,:);
        rver=rver+z(:,i).*w(:,i);
    end
end


hor=0;
ver=0;


for m=1:size(zm,2)
    if any(zm(:,m))
        C_r = ones(1,N);

        C_r(im{m})=cm{m};

        z=zm(:,m)*zm(:,m)';
        w=wm{m}(C_r, C_r);
        hor=hor+z(i,:).*w(i,:);
        ver=ver+z(:,i).*w(:,i);
    
    end
end




Thor=T_old(i,:)-rhor+hor;
Tver=T_old(:,i)-rver+ver;



%update T
T_old(i,:)=Thor;
T_old(:,i)=Tver;

Thor=Thor+param.bias;
Tver=Tver+param.bias;
% Thor(Thor==0)=Thor(Thor==0)+param.bias;
% Tver(Tver==0)=Tver(Tver==0)+param.bias;


Thor_=-log(1+exp(Thor));
Tver_= -log(1+exp(Tver));

Thor = settings.train_mask(i,:).*(R(i,:).*(Thor+Thor_)+(1-R(i,:)).*Thor_);

r=R(:,i);
%r(i)=[];
Tver =(settings.train_mask(:,i)).*( r.*(Tver+Tver_)+(1-r).*Tver_);


lkl = sum(Thor)+sum(Tver)-Tver(i);


end


