% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: August 2012
% Modified: August 2012


function [ param ] = exact_sampler_hyper_IBP( param)

% Consider a vague prior Gamma(shape, scale, 1) on alpha
% posterior alpha ∼ Gamma(shape + K, scale/(scale + H_N)), where K is the number of
% the active features and H_N is the harmonic mean
%prior_a = Gamma(1,1)

alpha=param.alpha;
Zs=param.Zscur;

% remove parts of z with no usages
% this is necessary for the finite case of sampling Z, since then we 
% might have all-zero columns
zeroInd = find( sum(Zs,1) == 0 );
Zs( :, zeroInd ) = [];


%% exact sampler 

[N K] = size(Zs);
hst = zeros(1,K);
for k=1:K
    hst(k)=bin2dec2(Zs(:,k));
end

K_plus = histc(hst,unique(hst));
K_plus=sum(K_plus);
harm = sum(ones(1, N)./[1:N]);

 M=size(param.Zscur,2);
 param.alpha=gamrnd( K_plus+param.alpha_shape , param.alpha_scale / ( 1 + harm*param.alpha_scale ) );
 
 
 

end




