function [ param ] = sample_bias(R, param, settings)
%SAMPLE_BIAS Summary of this function goes here
%   Detailed explanation goes here

Zs=param.Zscur;
Cs=param.Cscur;
Is=param.Iscur;
Ks=param.Kscur;
Ns=param.Nscur;
NNs=param.NNscur;
Ws=param.Wscur;


bias_init = param.bias;

log_prior = @(bias_init) -0.5*log(2*pi*param.bias_sigma^2) -((bias_init-param.bias_mu)^2)/(2*param.bias_sigma^2);


%likelihood term
lh = @(bias_init) lkhood(bias_init, R,Zs, Cs, Is, Ws, param, settings);
%target function

f = @(bias_init) lh(bias_init)+log_prior(bias_init);

N = 1;
param.bias= slicesample(bias_init,N,'logpdf',f,'thin',1,'burnin',0);


%no need for this. T doesn't change.
% [ lk_n T]=compute_likelihood(R, Zs, Cs, Is, Ws, param, settings);
% % param.lk = lk_n;
% param.T=T;



    function l=lkhood(bias, R, Zs, Cs, Is, Ws, param, settings)
        param.bias=bias;
        l=compute_likelihood(R, Zs, Cs, Is, Ws, param, settings);
        
        
    end



param.Zscur=Zs;
param.Cscur=Cs;
param.Iscur=Is;
param.Kscur=Ks;
param.Nscur=Ns;
param.NNscur=NNs;
param.Wscur=Ws;





end


