% function [Cs, Ks, NNs, Ws, param] = sample_c_single_iter_aux( R, Zs, Cs, Is, Ks, Ns, NNs, Ws, param, settings)
function [param] = sample_c_single_iter_aux( R,  param, settings)


% % sample posterior C given Z and W
% % use of Gibbs sampling with auxiliary parameters
% (R. M. Neal - Algorithm 8)

 Zs=param.Zscur;
 Cs=param.Cscur;
 Is=param.Iscur;
 Ks=param.Kscur;
 Ns=param.Nscur;
 NNs=param.NNscur;
 Ws=param.Wscur;


% disp('*********** c sample - aux')

M = size(Zs,2);



for m=1:M
%   fprintf('feature: %d \n', m);  
  
[Cs{m}, Ks(m), NNs{m}, Ws{m}, param  ] = sample_clusters(R, Zs(:,m), Cs{m}, Is{m}, Ks(m), Ns(m), NNs{m}, Ws{m}, param, settings);


end


 param.Zscur=Zs;
 param.Cscur=Cs;
 param.Iscur=Is;
 param.Kscur=Ks;
 param.Nscur=Ns;
 param.NNscur=NNs;
 param.Wscur=Ws;


end


