% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: February 2012


function [ Cs_m, Ks_m, NNs_m, Ws_m, param] = sample_clusters(R, Zs_m, Cs_m, Is_m, Ks_m, Ns_m, NNs_m, Ws_m, param, settings)

m_aux = settings.m_aux;
sigma_w =param.sigma_w;
mu_w = param.mu_w ;
% sigma_w1 = param.sigma_w1;
% mu_w1 = param.mu_w1 ;
% sigma_w2 = param.sigma_w2;
% mu_w2 = param.mu_w2 ;


ggamma = param.ggamma;


%sample the m_aux auxiliary variables independently from a normal
%distribution =N(mu_w, sigma_w^2)
perm=randperm(Ns_m);
for ind=1:Ns_m
    i=perm(ind);
    cm_old = Cs_m;
    wm_old = Ws_m;
    
    cluster = Cs_m(i); % cluster is current component that data item i belongs to
    NNs_m(cluster) = NNs_m(cluster) - 1; % subtract from number of data items in cluster
    % check if current cluster is singleton
    
    if NNs_m(cluster) == 0
        
        Ks_m = Ks_m - 1;
        NNs_m(cluster)=[];
        idx = find(Cs_m>cluster);
        Cs_m(idx) = Cs_m(idx) - 1;
        W_aux = cell(1, m_aux);
        self = Ws_m(cluster,cluster);
        col = Ws_m(:,cluster);
        col(cluster) = [];
        row = Ws_m(cluster,:);
        row(cluster) = [];
        
        
        Ws_m(cluster,:)=[];
        Ws_m(:,cluster)=[];
        W_aux{1} = [Ws_m col ];
        row = [row self];
        W_aux{1} = [W_aux{1}; row];
        
        for r=2:m_aux
            W_aux{r} = [Ws_m (mu_w+sigma_w * randn(1, Ks_m))'];
            W_aux{r} = [ W_aux{r};  mu_w+sigma_w * randn(1, Ks_m+1)];
        end
        %
        %         for r=2:m_aux
        %             ccol=zeros(1, Ks_m+1)';
        %             rrow=zeros(1, Ks_m+1);
        %             for cc=1:(Ks_m+1)
        %                 if rand<0.5
        %                     tw =param.mu_w1+param.sigma_w1*randn(1,1);
        %                     ccol(cc)=tw;
        %                     rrow(cc)=tw;
        %                 else
        %                     tw =param.mu_w2+param.sigma_w2*randn(1,1);
        %                     ccol(cc)=tw;
        %                     rrow(cc)=tw;
        %                 end
        %             end
        %
        %             W_aux{r} = [Ws_m ccol(1:(end-1))];
        %             W_aux{r} = [ W_aux{r}; rrow];
        %         end
        
    else
        W_aux = cell(1, m_aux);
        for r=1:m_aux
            W_aux{r} = [Ws_m (mu_w+sigma_w* randn(1, Ks_m))'];
            W_aux{r} = [W_aux{r};  mu_w+sigma_w * randn(1, Ks_m+1)];
            
        end
        
        
        %         for r=1:m_aux
        %
        %             ccol=zeros(1, Ks_m+1)';
        %             rrow=zeros(1, Ks_m+1);
        %             for cc=1:(Ks_m+1)
        %                 if rand<0.5
        %                     tw =param.mu_w1+param.sigma_w1*randn(1,1);
        %                     ccol(cc)=tw;
        %                     rrow(cc)=tw;
        %                 else
        %                     tw =param.mu_w2+param.sigma_w2*randn(1,1);
        %                     ccol(cc)=tw;
        %                     rrow(cc)=tw;
        %                 end
        %             end
        %
        %             W_aux{r} = [Ws_m ccol(1:(end-1))];
        %             W_aux{r} = [ W_aux{r}; rrow];
        %         end
        %
        
    end
    
    
    
    W_temp =Ws_m;
    C_temp = Cs_m;
    p= log(NNs_m.*(1/(ggamma+Ns_m-1)));
    p((end+1):(end+m_aux)) = log((ggamma/m_aux)) -log(ggamma+Ns_m-1);
    lh=zeros(1,Ks_m+m_aux);
    
    T=cell(1,Ks_m+m_aux);
    assert(length(p)==Ks_m+m_aux);
    for k = 1:Ks_m+m_aux
        
        if k<Ks_m+1
            C_temp(i)=k;
            
        else
            C_temp(i)=Ks_m+1;
            r = k - Ks_m;
            
            W_temp = W_aux{r};
            
        end
        
       
        
        [ lh(k) T{k} ] = compute_likelihood_new(Is_m(i), Zs_m, {cm_old}, {Is_m}, {wm_old}, R,  Zs_m, {C_temp}, {Is_m}, {W_temp}, param, settings);
        p(k) = p(k) +lh(k);
        
        
    end
    p = exp(p-max(p));
    p=p/(sum(p));
    
    
    % sample from the conditional probabilities
    uu = rand;
    kk = 1+sum(uu>cumsum(p));
    
    param.T=T{kk};
    %     param.lk=lh(kk);
    if kk>Ks_m
        Ws_m = W_aux{kk-Ks_m};
        kk = Ks_m+1;
        Ks_m=Ks_m+1;
        NNs_m(kk)=0;
        
    end
    
    Cs_m(i)=kk;
    NNs_m(kk) = NNs_m(kk) + 1; % increment number of data items in component kk
    assert(max(Cs_m) == size(Ws_m,2));
    
end


end
